
# I love OpenSource :-(

%define name		nvidia-current
%define version		177.70
%define rel		2
%define subrel 1

%define priority	9700

# pkg0: plain archive
# pkg1: + precompiled modules
# pkg2: + 32bit compatibility libraries
%define pkgname32	NVIDIA-Linux-x86-%{version}-pkg0
%define pkgname64	NVIDIA-Linux-x86_64-%{version}-pkg2

# For now, backportability is kept for 2006.0 / CS4 forwards.

%define nameprefix		x11-driver-video-
%define drivername		nvidia-current
%define driverpkgname		%{nameprefix}%{drivername}
%define modulename		%{drivername}
%define cards			GeForce 6 and later cards
%define xorg_libdir		%{_libdir}/xorg
%define nvidia_driversdir	%{xorg_libdir}/modules/drivers/%{drivername}
%define nvidia_extensionsdir	%{xorg_libdir}/modules/extensions/%{drivername}
%define nvidia_libdir		%{_libdir}/%{drivername}
%define nvidia_libdir32		%{_prefix}/lib/%{drivername}
%define nvidia_bindir		%{nvidia_libdir}/bin
%define nvidia_deskdir		%{_datadir}/%{drivername}
%define nvidia_xvmcconfdir	%{_sysconfdir}/%{drivername}
%define ld_so_conf_dir		%{_sysconfdir}/%{drivername}
%define ld_so_conf_file		ld.so.conf

%if %{mdkversion} <= 200710
%define nameprefix		%{nil}
%define drivername		nvidia97xx
%endif

%if %{mdkversion} <= 200700
%define drivername		nvidia
%define ld_so_conf_dir		%{_sysconfdir}/ld.so.conf.d/GL
%define ld_so_conf_file		%{drivername}.conf
%endif

%if %{mdkversion} <= 200600
%define xorg_libdir		%{_prefix}/X11R6/%{_lib}
%define ld_so_conf_dir		%{_sysconfdir}/ld.so.conf.d
%define nvidia_driversdir	%{xorg_libdir}/modules/drivers
%define nvidia_extensionsdir	%{xorg_libdir}/modules/extensions/nvidia
%define nvidia_bindir		%{_bindir}
%define nvidia_xvmcconfdir	%{_sysconfdir}/X11
%define nvidia_deskdir		%{_datadir}/applications
%endif

%define biarches x86_64
%ifarch %{ix86}
%define nsource %{SOURCE0}
%define pkgname %{pkgname32}
%endif
%ifarch x86_64
%define nsource %{SOURCE1}
%define pkgname %{pkgname64}
%endif

# Other packages should not require any NVIDIA libraries, and this package
# should not be pulled in when libGL.so.1 is required
%define _provides_exceptions \\.so
%define common_requires_exceptions libGLcore\\.so\\|libnvidia-tls\\.so

%ifarch %{biarches}
# (anssi) Allow installing of 64-bit package if the runtime dependencies
# of 32-bit libraries are not satisfied. If a 32-bit package that requires
# libGL.so.1 is installed, the 32-bit mesa libs are pulled in and that will
# pull the dependencies of 32-bit nvidia libraries in as well.
%define _requires_exceptions %common_requires_exceptions\\|lib.*so\\.[^(]\\+\\(([^)]\\+)\\)\\?$
%else
%define _requires_exceptions %common_requires_exceptions
%endif

Summary:	NVIDIA proprietary X.org driver and libraries, current driver series
Name:		%{name}
Version:	%{version}
Release:	%mkrel %{rel}
Source0:	ftp://download.nvidia.com/XFree86/Linux-x86/%{version}/%{pkgname32}.run
Source1:	ftp://download.nvidia.com/XFree86/Linux-x86_64/%{version}/%{pkgname64}.run
# Use upstream Xen detection from next version
Source3:	nvidia-2.6.27-xen.patch
License:	Proprietary
BuildRoot:	%{_tmppath}/%{name}-buildroot
URL:		http://www.nvidia.com/object/unix.html
Group: 		System/Kernel and hardware
ExclusiveArch:	%{ix86} x86_64
BuildRequires:	ImageMagick
%if "%{driverpkgname}" == "nvidia"
# old nvidia package had different versioning
Epoch:		1
%endif

%description
Source package of the current NVIDIA proprietary driver. Binary
packages are named x11-driver-video-nvidia-current on Mandriva Linux
2008, nvidia97xx on Mandriva 2007.1, and nvidia on 2007.0 and
earlier.

%package -n %{driverpkgname}
Summary:	NVIDIA proprietary X.org driver and libraries for %cards
Group: 		System/Kernel and hardware
%if %{mdkversion} >= 200700
# Older alternatives implementations were buggy in various ways:
Requires(post): update-alternatives >= 1.9.0
Requires(postun): update-alternatives >= 1.9.0
%endif
%if %{mdkversion} >= 200800
# Proprietary driver handling rework:
Conflicts:	harddrake < 10.4.163
Conflicts:	drakx-kbd-mouse-x11 < 0.21
Conflicts:	x11-server-common < 1.3.0.0-17
# Suggests supported as of 2008.0, pull the rest of docs:
Suggests:	%{drivername}-doc-html
%endif
%if %{mdkversion} >= 200810
# for missing libwfb.so
Conflicts:	x11-server-common < 1.4
# Proper support for versioned kmod() was added in 2008.1:
Requires:	kmod(%{modulename}) = %{version}
%endif
# Some very old obsoletes, could be probably removed soon:
Obsoletes:	NVIDIA_GLX
Provides:	NVIDIA_GLX
# Obsoletes for naming changes:
%if %{mdkversion} >= 200710
Obsoletes:	nvidia < 1:%{version}-%{release}
Provides:	nvidia = 1:%{version}-%{release}
%endif
%if %{mdkversion} >= 200800
Obsoletes:	nvidia97xx < %{version}-%{release}
Provides:	nvidia97xx = %{version}-%{release}
%endif

%description -n %{driverpkgname}
NVIDIA proprietary X.org graphics driver, related libraries and
configuration tools for %cards,
including the associated Quadro cards.

NOTE: You should use XFdrake to configure your NVIDIA card. The
correct packages will be automatically installed and configured.

If you do not want to use XFdrake, see README.manual-setup.

This NVIDIA driver should be used with %cards,
including the associated Quadro cards.
For older cards, the packages %{nameprefix}nvidia96xx and
%{nameprefix}nvidia71xx should be used instead.

%package -n dkms-%{drivername}
Summary:	NVIDIA kernel module for %cards
Group:		System/Kernel and hardware
Requires:	dkms
Requires(post):	dkms
Requires(preun): dkms
Requires:	%{driverpkgname} = %{version}
%if %{mdkversion} >= 200710
Obsoletes:	dkms-nvidia < 1:%{version}-%{release}
Provides:	dkms-nvidia = 1:%{version}-%{release}
%endif
%if %{mdkversion} >= 200800
Obsoletes:	dkms-nvidia97xx < %{version}-%{release}
Provides:	dkms-nvidia97xx = %{version}-%{release}
%endif

%description -n dkms-%{drivername}
NVIDIA kernel module for %cards. This
is to be used with the %{driverpkgname} package.

%package -n %{drivername}-devel
Summary:	NVIDIA XvMC development library and OpenGL headers
Group:		Development/C
Requires:	%{driverpkgname} = %{version}-%{release}
%if %{mdkversion} >= 200710
Obsoletes:	nvidia-devel < 1:%{version}-%{release}
Provides:	nvidia-devel = 1:%{version}-%{release}
%endif
%if %{mdkversion} >= 200800
Obsoletes:	nvidia97xx-devel < %{version}-%{release}
Provides:	nvidia97xx-devel = %{version}-%{release}
%endif

%description -n %{drivername}-devel
NVIDIA XvMC static development library and OpenGL headers for
%cards. This package is not required for
normal use.

# HTML doc splitted off because of size, for Mandriva One:
%package -n %{drivername}-doc-html
Summary:	NVIDIA html documentation (%{drivername})
Group:		System/Kernel and hardware
Requires:	%{driverpkgname} = %{version}-%{release}

%description -n %{drivername}-doc-html
HTML version of the README.txt file provided in package
%{driverpkgname}.

%prep
%setup -c -T
sh %{nsource} --extract-only
rm -rf %{pkgname}/usr/src/nv/precompiled

# Now works properly on xen, as reported by guillomovitch, so remove the xen
# check:
perl -pi -e 's/^module:(.*) xen-sanity-check (.*)$/module:$1 $2/' \
    %{pkgname}/usr/src/nv/Makefile.kbuild

cat > README.install.urpmi <<EOF
This driver is for %cards.

Use XFdrake to configure X to use the correct NVIDIA driver. Any needed
packages will be automatically installed if not already present.
1. Run XFdrake as root.
2. Go to the Graphics Card list.
3. Select your card (it is usually already autoselected).
4. Answer any questions asked and then quit.

If you do not want to use XFdrake, see README.manual-setup.
EOF

cat > README.manual-setup <<EOF
This file describes the procedure for the manual installation of this NVIDIA
driver package. You can find the instructions for the recommended automatic
installation in the file 'README.install.urpmi' in this directory.

- Open %{_sysconfdir}/X11/xorg.conf and make the following changes:
  o Change the Driver to "nvidia" in the Device section
  o Make the line below the only 'glx' related line in the Module section:
%if %{mdkversion} >= 200710
      Load "glx"
%if %{mdkversion} >= 200800
  o Remove any 'ModulePath' lines from the Files section
%else
  o Make the lines below the only 'ModulePath' lines in the Files section:
      ModulePath "%{nvidia_extensionsdir}"
      ModulePath "%{xorg_libdir}/modules"
%endif
%else
      Load "%{nvidia_extensionsdir}/libglx.so"
%endif
%if %{mdkversion} >= 200700
- Run "update-alternatives --set gl_conf %{ld_so_conf_dir}/%{ld_so_conf_file}" as root.
- Run "ldconfig" as root.
%endif
EOF

mv %{pkgname}/usr/share/doc/html html-doc

%install
rm -rf %{buildroot}
cd %{pkgname}/usr

# dkms
install -d -m755 %{buildroot}%{_usrsrc}/%{drivername}-%{version}-%{release}
install -m644 src/nv/* %{buildroot}%{_usrsrc}/%{drivername}-%{version}-%{release}
chmod 0755 %{buildroot}%{_usrsrc}/%{drivername}-%{version}-%{release}/conftest.sh

install -d -m755 %{buildroot}%{_usrsrc}/%{drivername}-%{version}-%{release}/patches
install -m644 %{SOURCE3} %{buildroot}%{_usrsrc}/%{drivername}-%{version}-%{release}/patches
# -p1 for dkms:
#sed -i 's,usr/src/nv,nv,g' %{buildroot}%{_usrsrc}/%{drivername}-%{version}-%{release}/patches/*.diff.txt

cat > %{buildroot}%{_usrsrc}/%{drivername}-%{version}-%{release}/dkms.conf <<EOF
PACKAGE_NAME="%{drivername}"
PACKAGE_VERSION="%{version}-%{release}"
BUILT_MODULE_NAME[0]="nvidia"
DEST_MODULE_LOCATION[0]="/kernel/drivers/char/drm"
%if %{mdkversion} >= 200710
DEST_MODULE_NAME[0]="%{modulename}"
%endif
MAKE[0]="make SYSSRC=\${kernel_source_dir} module"
CLEAN="make -f Makefile.kbuild clean"
AUTOINSTALL="yes"
PATCH[0]="nvidia-2.6.27-xen.patch"
PATCH_MATCH[0]="^2.6.2[4-9]"
EOF

# OpenGL and CUDA headers
install -d -m755	%{buildroot}%{_includedir}/%{drivername}
cp -a include/*		%{buildroot}%{_includedir}/%{drivername}

# install binaries
install -d -m755			%{buildroot}%{nvidia_bindir}
install -m755 bin/nvidia-settings	%{buildroot}%{nvidia_bindir}
install -m755 bin/nvidia-smi		%{buildroot}%{nvidia_bindir}
install -m755 bin/nvidia-xconfig	%{buildroot}%{nvidia_bindir}
install -m755 bin/nvidia-bug-report.sh	%{buildroot}%{nvidia_bindir}
%if %{mdkversion} >= 200700
install -d -m755			%{buildroot}%{_bindir}
touch					%{buildroot}%{_bindir}/nvidia-settings
touch					%{buildroot}%{_bindir}/nvidia-smi
touch					%{buildroot}%{_bindir}/nvidia-xconfig
touch					%{buildroot}%{_bindir}/nvidia-bug-report.sh
# rpmlint:
chmod 0755				%{buildroot}%{_bindir}/*
%endif

# install man pages
install -d -m755				%{buildroot}%{_mandir}/man1
install -m644 share/man/man1/nvidia-xconfig*	%{buildroot}%{_mandir}/man1
install -m644 share/man/man1/nvidia-settings*	%{buildroot}%{_mandir}/man1
%if %{mdkversion} >= 200700
cd %{buildroot}%{_mandir}/man1
rename nvidia .%{drivername} *
cd -
touch %{buildroot}%{_mandir}/man1/nvidia-xconfig.1%{_extension}
touch %{buildroot}%{_mandir}/man1/nvidia-settings.1%{_extension}
%endif

# menu entry
%if %{mdkversion} <= 200600
install -d -m755 %{buildroot}/%{_menudir}
cat <<EOF >%{buildroot}/%{_menudir}/%{driverpkgname}
?package(%{driverpkgname}):command="%{nvidia_bindir}/nvidia-settings" \
                  icon=%{drivername}-settings.png \
                  needs="x11" \
                  section="System/Configuration/Hardware" \
                  title="NVIDIA Display Settings" \
                  longtitle="Configure NVIDIA X driver" \
                  xdg="true"
EOF
%endif

install -d -m755 %{buildroot}%{nvidia_deskdir}
cat > %{buildroot}%{nvidia_deskdir}/mandriva-nvidia-settings.desktop <<EOF
[Desktop Entry]
Name=NVIDIA Display Settings
Comment=Configure NVIDIA X driver
Exec=%{_bindir}/nvidia-settings
Icon=%{drivername}-settings
Terminal=false
Type=Application
Categories=GTK;Settings;HardwareSettings;X-MandrivaLinux-System-Configuration;
EOF

install -d -m755	%{buildroot}%{_datadir}/applications
touch			%{buildroot}%{_datadir}/applications/mandriva-nvidia-settings.desktop

# icons
install -d -m755 %{buildroot}/%{_miconsdir} %{buildroot}/%{_iconsdir} %{buildroot}/%{_liconsdir}
convert share/pixmaps/nvidia-settings.png -resize 16x16 %{buildroot}/%{_miconsdir}/%{drivername}-settings.png
convert share/pixmaps/nvidia-settings.png -resize 32x32 %{buildroot}/%{_iconsdir}/%{drivername}-settings.png
convert share/pixmaps/nvidia-settings.png -resize 48x48 %{buildroot}/%{_liconsdir}/%{drivername}-settings.png

# install libraries
install -d -m755						%{buildroot}%{nvidia_libdir}/tls
install -m755 lib/tls/libnvidia-tls.so.%{version}		%{buildroot}%{nvidia_libdir}/tls
install -m755 lib/libnvidia-tls.so.%{version}			%{buildroot}%{nvidia_libdir}
install -m755 lib/libnvidia-cfg.so.%{version}			%{buildroot}%{nvidia_libdir}
install -m755 lib/libcuda.so.%{version}				%{buildroot}%{nvidia_libdir}
install -m755 lib/libGL.so.%{version}				%{buildroot}%{nvidia_libdir}
install -m755 lib/libGLcore.so.%{version}			%{buildroot}%{nvidia_libdir}
install -m755 X11R6/lib/libXvMCNVIDIA.so.%{version}		%{buildroot}%{nvidia_libdir}
install -m755 X11R6/lib/libXvMCNVIDIA.a				%{buildroot}%{nvidia_libdir}
/sbin/ldconfig -n						%{buildroot}%{nvidia_libdir}
ln -s libcuda.so.1						%{buildroot}%{nvidia_libdir}/libcuda.so
ln -s libGL.so.1						%{buildroot}%{nvidia_libdir}/libGL.so
ln -s libnvidia-cfg.so.1					%{buildroot}%{nvidia_libdir}/libnvidia-cfg.so
sed 's,__LIBGL_PATH__,%{nvidia_libdir},' lib/libGL.la >		%{buildroot}%{nvidia_libdir}/libGL.la
%ifarch %{biarches}
install -d -m755						%{buildroot}%{nvidia_libdir32}/tls
install -m755 lib32/tls/libnvidia-tls.so.%{version}		%{buildroot}%{nvidia_libdir32}/tls
install -m755 lib32/libnvidia-tls.so.%{version}			%{buildroot}%{nvidia_libdir32}
install -m755 lib32/libcuda.so.%{version}			%{buildroot}%{nvidia_libdir32}
install -m755 lib32/libGL.so.%{version}				%{buildroot}%{nvidia_libdir32}
install -m755 lib32/libGLcore.so.%{version}			%{buildroot}%{nvidia_libdir32}
/sbin/ldconfig -n						%{buildroot}%{nvidia_libdir32}
ln -s libcuda.so.1						%{buildroot}%{nvidia_libdir32}/libcuda.so
ln -s libGL.so.1						%{buildroot}%{nvidia_libdir32}/libGL.so
ln -s libnvidia-cfg.so.1					%{buildroot}%{nvidia_libdir32}/libnvidia-cfg.so
sed 's,__LIBGL_PATH__,%{nvidia_libdir32},' lib32/libGL.la >	%{buildroot}%{nvidia_libdir32}/libGL.la
%endif

# install X.org files
install -d -m755						%{buildroot}%{xorg_libdir}/modules
install -m755 X11R6/lib/modules/libnvidia-wfb.so.%{version}	%{buildroot}%{xorg_libdir}/modules
/sbin/ldconfig -n						%{buildroot}%{xorg_libdir}/modules
%if %{mdkversion} <= 200800
# provided by xorg server 1.4
ln -s libnvidia-wfb.so.1					%{buildroot}%{xorg_libdir}/modules/libwfb.so
%endif
install -d -m755						%{buildroot}%{nvidia_extensionsdir}
install -m755 X11R6/lib/modules/extensions/libglx.so.%{version}	%{buildroot}%{nvidia_extensionsdir}
ln -s libglx.so.%{version}					%{buildroot}%{nvidia_extensionsdir}/libglx.so
mkdir -p							%{buildroot}%{nvidia_driversdir}
install -m755 X11R6/lib/modules/drivers/nvidia_drv.so		%{buildroot}%{nvidia_driversdir}
%if %{mdkversion} >= 200700
touch								%{buildroot}%{xorg_libdir}/modules/drivers/nvidia_drv.so
%endif
%if %{mdkversion} >= 200800
touch								%{buildroot}%{xorg_libdir}/modules/extensions/libglx.so
%endif

# ld.so.conf
install -d -m755		%{buildroot}%{ld_so_conf_dir}
echo "%{nvidia_libdir}" >	%{buildroot}%{ld_so_conf_dir}/%{ld_so_conf_file}
%ifarch %{biarches}
echo "%{nvidia_libdir32}" >>	%{buildroot}%{ld_so_conf_dir}/%{ld_so_conf_file}
%endif
%if %{mdkversion} >= 200700
install -d -m755		%{buildroot}%{_sysconfdir}/ld.so.conf.d
touch				%{buildroot}%{_sysconfdir}/ld.so.conf.d/GL.conf
%endif

# modprobe.conf
%if %{mdkversion} >= 200710
install -d -m755			%{buildroot}%{_sysconfdir}/modprobe.d
touch					%{buildroot}%{_sysconfdir}/modprobe.d/nvidia.conf
echo "alias nvidia %{modulename}" >	%{buildroot}%{_sysconfdir}/%{drivername}/modprobe.conf
%endif

# XvMCConfig
install -d -m755 %{buildroot}%{nvidia_xvmcconfdir}
echo "libXvMCNVIDIA_dynamic.so.1" > %{buildroot}%{nvidia_xvmcconfdir}/XvMCConfig

install -d -m755 %{buildroot}%{_sysconfdir}/X11/xinit.d
cat > %{buildroot}%{_sysconfdir}/X11/xinit.d/01nvidia-performance <<EOF
# to be sourced
if [ "\$(readlink %{_sysconfdir}/alternatives/gl_conf)" = "%{ld_so_conf_dir}/%{ld_so_conf_file}" ]; then
	nvidia-settings -a InitialPixmapPlacement=2 -a GlyphCache=1
fi
EOF
chmod 0755 %{buildroot}%{_sysconfdir}/X11/xinit.d/01nvidia-performance

# don't strip files
export DONT_STRIP=1

%post -n %{driverpkgname}
%if %{mdkversion} >= 200710
# XFdrake used to generate an nvidia.conf file
[ -L %{_sysconfdir}/modprobe.d/nvidia.conf ] || rm -f %{_sysconfdir}/modprobe.d/nvidia.conf
%endif

%if %{mdkversion} >= 200700
current_glconf="$(readlink -e %{_sysconfdir}/ld.so.conf.d/GL.conf)"

%if %{mdkversion} < 200800
# Handle upgrading from setups where libwfb was not using alternatives.
# From 2008.0 onwards the calling of --set after --install on rename makes
# this unnecessary.
if [ "${current_glconf}" = "%{_sysconfdir}/nvidia97xx/ld.so.conf" ]; then
	wfblink="$(readlink %{_libdir}/xorg/modules/libnvidia-wfb.so.1)"
	if [ "${wfblink%.so.1*}" = "libnvidia-wfb" ]; then
		# The below update-alternatives will recreate this
		/bin/rm %{_libdir}/xorg/modules/libnvidia-wfb.so.1
	fi
fi
%endif

%define compat_ext %([ "%{_extension}" == ".bz2" ] || echo %{_extension})
%{_sbindir}/update-alternatives \
	--install %{_sysconfdir}/ld.so.conf.d/GL.conf gl_conf %{ld_so_conf_dir}/%{ld_so_conf_file} %{priority} \
	--slave %{_libdir}/xorg/modules/drivers/nvidia_drv.so nvidia_drv %{_libdir}/xorg/modules/drivers/%{drivername}/nvidia_drv.so \
	--slave %{_libdir}/xorg/modules/libnvidia-wfb.so.1 nvidia_wfb %{_libdir}/xorg/modules/libnvidia-wfb.so.%{version} \
	--slave %{_mandir}/man1/nvidia-settings.1%{_extension} man_nvidiasettings%{compat_ext} %{_mandir}/man1/.%{drivername}-settings.1%{_extension} \
	--slave %{_mandir}/man1/nvidia-xconfig.1%{_extension} man_nvidiaxconfig%{compat_ext} %{_mandir}/man1/.%{drivername}-xconfig.1%{_extension} \
	--slave %{_datadir}/applications/mandriva-nvidia-settings.desktop nvidia_desktop %{nvidia_deskdir}/mandriva-nvidia-settings.desktop \
	--slave %{_bindir}/nvidia-settings nvidia_settings %{nvidia_bindir}/nvidia-settings \
	--slave %{_bindir}/nvidia-smi nvidia_smi %{nvidia_bindir}/nvidia-smi \
	--slave %{_bindir}/nvidia-xconfig nvidia_xconfig %{nvidia_bindir}/nvidia-xconfig \
	--slave %{_bindir}/nvidia-bug-report.sh nvidia_bug_report %{nvidia_bindir}/nvidia-bug-report.sh \
	--slave %{_sysconfdir}/X11/XvMCConfig xvmcconfig %{nvidia_xvmcconfdir}/XvMCConfig \
%if %{mdkversion} <= 200800
	--slave %{_libdir}/xorg/modules/libwfb.so libwfb %{_libdir}/xorg/modules/libnvidia-wfb.so.%{version} \
%endif
%if %{mdkversion} >= 200710
	--slave %{_sysconfdir}/modprobe.d/nvidia.conf nvidia_modconf %{_sysconfdir}/%{drivername}/modprobe.conf \
%endif
%if %{mdkversion} >= 200900
	--slave %{_libdir}/xorg/modules/extensions/libdri.so libdri.so %{_libdir}/xorg/modules/extensions/standard/libdri.so \
%endif
%if %{mdkversion} >= 200800
	--slave %{_libdir}/xorg/modules/extensions/libglx.so libglx %{nvidia_extensionsdir}/libglx.so
if [ "${current_glconf}" = "%{_sysconfdir}/nvidia97xx/ld.so.conf" ]; then
	# Adapt for the renaming of the driver. X.org config still has the old ModulePaths
	# but they do not matter as we are using alternatives for libglx.so now.
	%{_sbindir}/update-alternatives --set gl_conf %{ld_so_conf_dir}/%{ld_so_conf_file}
fi
%endif
# empty line so that /sbin/ldconfig is not passed to update-alternatives
%endif
# explicit /sbin/ldconfig due to alternatives
/sbin/ldconfig

%postun -n %{driverpkgname}
%if %{mdkversion} >= 200700
if [ ! -f %{ld_so_conf_dir}/%{ld_so_conf_file} ]; then
  %{_sbindir}/update-alternatives --remove gl_conf %{ld_so_conf_dir}/%{ld_so_conf_file}
fi
%endif
# explicit /sbin/ldconfig due to alternatives
/sbin/ldconfig

%post -n dkms-%{drivername}
/usr/sbin/dkms --rpm_safe_upgrade add -m %{drivername} -v %{version}-%{release} &&
/usr/sbin/dkms --rpm_safe_upgrade build -m %{drivername} -v %{version}-%{release} &&
/usr/sbin/dkms --rpm_safe_upgrade install -m %{drivername} -v %{version}-%{release} --force

# rmmod any old driver if present and not in use (e.g. by X)
rmmod nvidia > /dev/null 2>&1 || true

%preun -n dkms-%{drivername}
/usr/sbin/dkms --rpm_safe_upgrade remove -m %{drivername} -v %{version}-%{release} --all

# rmmod any old driver if present and not in use (e.g. by X)
rmmod nvidia > /dev/null 2>&1 || true

%clean
rm -rf %{buildroot}

%files -n %{driverpkgname}
%defattr(-,root,root)

%doc README.install.urpmi README.manual-setup
%doc %{pkgname}/usr/share/doc/*
%doc %{pkgname}/LICENSE

# ld.so.conf, modprobe.conf, xvmcconfig
%if %{mdkversion} >= 200710
# 2007.1
%ghost %{_sysconfdir}/ld.so.conf.d/GL.conf
%ghost %{_sysconfdir}/modprobe.d/nvidia.conf
%dir %{_sysconfdir}/%{drivername}
%{_sysconfdir}/%{drivername}/modprobe.conf
%{_sysconfdir}/%{drivername}/ld.so.conf
%{_sysconfdir}/%{drivername}/XvMCConfig
%else
%if %{mdkversion} >= 200700
# 2007.0
%ghost %{_sysconfdir}/ld.so.conf.d/GL.conf
%dir %{_sysconfdir}/ld.so.conf.d/GL
%dir %{_sysconfdir}/%{drivername}
%{_sysconfdir}/ld.so.conf.d/GL/%{drivername}.conf
%{_sysconfdir}/%{drivername}/XvMCConfig
%else
# 2006.0
%config(noreplace) %{_sysconfdir}/X11/XvMCConfig
%config(noreplace) %{_sysconfdir}/ld.so.conf.d/%{drivername}.conf
%endif
%endif

%{_sysconfdir}/X11/xinit.d/01nvidia-performance

%if %{mdkversion} >= 200700
%ghost %{_bindir}/nvidia-settings
%ghost %{_bindir}/nvidia-smi
%ghost %{_bindir}/nvidia-xconfig
%ghost %{_bindir}/nvidia-bug-report.sh
%dir %{nvidia_bindir}
%endif
%{nvidia_bindir}/nvidia-settings
%{nvidia_bindir}/nvidia-smi
%{nvidia_bindir}/nvidia-xconfig
%{nvidia_bindir}/nvidia-bug-report.sh

%if %{mdkversion} >= 200700
%ghost %{_mandir}/man1/nvidia-xconfig.1%{_extension}
%ghost %{_mandir}/man1/nvidia-settings.1%{_extension}
%{_mandir}/man1/.%{drivername}-xconfig.1*
%{_mandir}/man1/.%{drivername}-settings.1*
%else
%{_mandir}/man1/nvidia-xconfig.1*
%{_mandir}/man1/nvidia-settings.1*
%endif

%if %{mdkversion} >= 200700
%ghost %{_datadir}/applications/mandriva-nvidia-settings.desktop
%dir %{nvidia_deskdir}
%else
%{_menudir}/%{driverpkgname}
%endif
%{nvidia_deskdir}/mandriva-nvidia-settings.desktop

%{_miconsdir}/%{drivername}-settings.png
%{_iconsdir}/%{drivername}-settings.png
%{_liconsdir}/%{drivername}-settings.png

%dir %{nvidia_libdir}
%dir %{nvidia_libdir}/tls
%{nvidia_libdir}/*.so.%{version}
%{nvidia_libdir}/*.so.1
%{nvidia_libdir}/tls/*.so.%{version}
%{nvidia_libdir}/tls/*.so.1
%ifarch %{biarches}
%dir %{nvidia_libdir32}
%dir %{nvidia_libdir32}/tls
%{nvidia_libdir32}/*.so.%{version}
%{nvidia_libdir32}/*.so.1
%{nvidia_libdir32}/tls/*.so.%{version}
%{nvidia_libdir32}/tls/*.so.1
%endif

%if %{mdkversion} >= 200700
# 2007.0 -
%ghost %{xorg_libdir}/modules/libnvidia-wfb.so.1
%if %{mdkversion} <= 200800
# 2007.0 - 2008.0
%ghost %{xorg_libdir}/modules/libwfb.so
%endif
%else
# - 2006.0
%{xorg_libdir}/modules/libwfb.so
%{xorg_libdir}/modules/libnvidia-wfb.so.1
%endif
%{xorg_libdir}/modules/libnvidia-wfb.so.%{version}

%dir %{nvidia_extensionsdir}
%{nvidia_extensionsdir}/libglx.so.%{version}
%{nvidia_extensionsdir}/libglx.so
%if %{mdkversion} >= 200800
%ghost %{xorg_libdir}/modules/extensions/libglx.so
%endif

%if %{mdkversion} >= 200700
%ghost %{xorg_libdir}/modules/drivers/nvidia_drv.so
%dir %{nvidia_driversdir}
%endif
%{nvidia_driversdir}/nvidia_drv.so

%files -n %{drivername}-devel
%defattr(-,root,root)
%{_includedir}/%{drivername}
%{nvidia_libdir}/libXvMCNVIDIA.a
%{nvidia_libdir}/*.so
%{nvidia_libdir}/*.la
%ifarch %{biarches}
%{nvidia_libdir32}/*.so
%{nvidia_libdir32}/*.la
%endif

%files -n dkms-%{drivername}
%defattr(-,root,root)
%doc %{pkgname}/LICENSE
%{_usrsrc}/%{drivername}-%{version}-%{release}

%files -n %{drivername}-doc-html
%defattr(-,root,root)
%doc html-doc/*



%changelog
* Wed Oct 15 2008 Pascal Terjan <pterjan@mandriva.org> 177.70-2.1mdv2009.0
+ Revision: 293925
- Replace our patch with upstream fix from new driver
- Simplify the xen patch to ensure it loads on kernel-server

* Sat Oct 04 2008 Anne Nicolas <anne.nicolas@mandriva.com> 177.70-2mdv2009.0
+ Revision: 291122
- Fix #43716

* Wed Sep 03 2008 Stéphane Téletchéa <steletch@mandriva.org> 177.70-1mdv2009.0
+ Revision: 279745
- new beta version

* Sat Aug 23 2008 Anssi Hannula <anssi@mandriva.org> 177.68-1mdv2009.0
+ Revision: 275306
- new beta version

* Sun Aug 10 2008 Anssi Hannula <anssi@mandriva.org> 177.13-2mdv2009.0
+ Revision: 270245
- adapt for libdri.so handled by alternatives

* Sun Jul 20 2008 Anssi Hannula <anssi@mandriva.org> 177.13-1mdv2009.0
+ Revision: 239191
- new beta version
  o now supports only GF6 and newer chips
- update file list
- define %%cards for supported cards
- generalize %%driverpkgname

* Tue Jun 17 2008 Anssi Hannula <anssi@mandriva.org> 173.14.09-3mdv2009.0
+ Revision: 223065
- new version
- update installed files
- remove nvidia-settings workaround, fixed upstream
- remove 2.6.26 support patch, applied upstream
- call ldconfig explicitely, not handled by filetriggers in this case

  + Pixel <pixel@mandriva.com>
    - do not call ldconfig in %%post/%%postun, it is now handled by filetriggers

* Mon Jun 09 2008 Anssi Hannula <anssi@mandriva.org> 173.14.05-2mdv2009.0
+ Revision: 217092
- workaround modeline parsing bug in nvidia-settings with LC_NUMERIC=C
  (known upstream, fixed in the next release, reported by Philippe Didier)
- add some comments

* Thu May 29 2008 Anssi Hannula <anssi@mandriva.org> 173.14.05-1mdv2009.0
+ Revision: 212850
- new version
- update 2.6.26 patch

* Sun May 11 2008 Anssi Hannula <anssi@mandriva.org> 173.08-2mdv2009.0
+ Revision: 205443
- add support for 2.6.26 (conditional upstream 2404825.diff)

* Mon Apr 14 2008 Anssi Hannula <anssi@mandriva.org> 173.08-1mdv2009.0
+ Revision: 192856
- new beta version
- restore menu for old releases

* Tue Apr 01 2008 Anssi Hannula <anssi@mandriva.org> 169.12-4mdv2008.1
+ Revision: 191502
- add versioned requires on kernel module on 2008.1

* Thu Mar 27 2008 Anssi Hannula <anssi@mandriva.org> 169.12-3mdv2008.1
+ Revision: 190679
- add upstream patch for 2.6.25 support, enabled conditionally

* Thu Mar 20 2008 Anssi Hannula <anssi@mandriva.org> 169.12-2mdv2008.1
+ Revision: 189241
- split html version of the documentation into nvidia-current-doc-html
- do not ship headers in documentation directory

* Fri Feb 29 2008 Anssi Hannula <anssi@mandriva.org> 169.12-1mdv2008.1
+ Revision: 176725
- new version

* Tue Jan 22 2008 Anssi Hannula <anssi@mandriva.org> 169.09-1mdv2008.1
+ Revision: 156466
- 169.09
  o fixes a problem causing the fan on some GPUs to always run at full
    speed
  o fixes a bug that caused the X driver to crash if the X.Org GLX
    extension module was loaded intead of NVIDIA's
  o improves the X driver's awareness of the current notebook docking
    status
  o fixes brightness control on HP Compaq notebooks
  o fixes a bug in the Linux/i2c algorithm driver implementation that
    prevented core transfer types from succeeding
- do not use Pascal's patch, it did not work

  + Pascal Terjan <pterjan@mandriva.org>
    - Don't disable AGP if Xen is compiled in but not in use

  + Thierry Vignaud <tvignaud@mandriva.com>
    - drop old menu

* Tue Dec 25 2007 Anssi Hannula <anssi@mandriva.org> 169.07-1mdv2008.1
+ Revision: 137623
- 169.07
- drop 2.6.24 support patch, fixed upstream

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Thierry Vignaud <tvignaud@mandriva.com>
    - kill re-definition of %%buildroot on Pixel's request

* Fri Dec 07 2007 Anssi Hannula <anssi@mandriva.org> 169.04-2mdv2008.1
+ Revision: 116285
- add patch for general 2.6.24 compatibility (S2, #35771)
- add patch for 2.6.24 xen compatibility, which actually mostly disables
  xen functionality, due to xen_features and hypercall_page, which are
  indirectly called by nvidia driver through macros in xen header files,
  now being GPL-only (S3)

* Wed Nov 21 2007 Anssi Hannula <anssi@mandriva.org> 169.04-1mdv2008.1
+ Revision: 111009
- 169.04 (beta)

* Fri Oct 19 2007 Anssi Hannula <anssi@mandriva.org> 100.14.19-3mdv2008.1
+ Revision: 100337
- on cooker, use libwfb.so from xorg server 1.4 instead of the NVIDIA
  provided one (according to documentation, this is also what NVIDIA's
  installer does)

* Mon Oct 15 2007 Anssi Hannula <anssi@mandriva.org> 100.14.19-2mdv2008.1
+ Revision: 98746
- handle upgrading from nvidia packages that do not have the libwfb files
  handled by alternatives (this change affects 2007.1 and earlier only,
  the problem does not exist when upgrading to 2008.0)
- use Makefile.kbuild explicitely for cleaning to prevent bad exit
  status during cleaning of the build area

* Mon Sep 24 2007 Anssi Hannula <anssi@mandriva.org> 100.14.19-1mdv2008.0
+ Revision: 92507
- add GTK category to the menu entry
- 100.14.19
  o adds support for Quadro FX 290,370,570,1700 GPUs
  o fixes GLX_EXT_texture_from_pixmap black window bug
  o fixes hang on logout with some hardware when 3d desktop is enabled
    (bug #33007)
  o lots of other bugfixes and improvements
- drop 2.6.23 support patch, fixed upstream

* Sat Sep 22 2007 Anssi Hannula <anssi@mandriva.org> 100.14.11-5mdv2008.0
+ Revision: 92226
- handle renaming of the driver from nvidia97xx as it can now be done
  easily due to the use of alternatives for libglx.so

* Fri Sep 07 2007 Anssi Hannula <anssi@mandriva.org> 100.14.11-4mdv2008.0
+ Revision: 81948
- fix 2.6.23 compatibility (NVIDIA_kernel-2.6.23.txt)

* Fri Aug 31 2007 Anssi Hannula <anssi@mandriva.org> 100.14.11-3mdv2008.0
+ Revision: 76854
- allow building against xen kernel (Guillaume Rousse)
- fix alternatives on backports

  + Thierry Vignaud <tvignaud@mandriva.com>
    - kill desktop-file-validate's 'warning: key "Encoding" in group "Desktop Entry" is deprecated'

* Sun Aug 26 2007 Anssi Hannula <anssi@mandriva.org> 100.14.11-2mdv2008.0
+ Revision: 71694
- use alternatives for libglx.so
- rename source rpm to nvidia-current to allow renaming binary packages
  when backporting to old releases
- shorten dkms driver name
- drop old requires on drakxtools
- use conflicts instead of requires on harddrake and drakx-kbd-mouse-x11
  (Thierry Vignaud)

* Thu Aug 09 2007 Anssi Hannula <anssi@mandriva.org> 100.14.11-1mdv2008.0
+ Revision: 60655
- do not call the next dkms step if previous fails
- rename from nvidia97xx to x11-driver-video-nvidia-current
- versionize obsoletes to avoid future problems
- add devel package (requested by Giuseppe)
- add support for 2006.0 (requested by Giuseppe)
- better descriptions and summaries
- add README.install.urpmi and README.manual-setup
- provide XvMCConfig via alternatives (bug #29109)
- add post and preun script requires on dkms
- require new update-alternatives instead of workarounding bugs
- include nvidia tools, handled by alternatives (bug #29107)
- add URL
- clean libGL.so.1 from provides (bug #28216)
- remove packager tag, prefix tag, requires on glibc
- fix file requires
- 100.14.11
- clean .spec
- fix 2007.0 compatibility
- drop unneeded ioctl32.patch
- use %%{version}-%%{release} for dkms PACKAGE_VERSION
- alternativeszificate unversioned libwfb.so properly
- do not add nvidia to modprobe.preload in 2007.0 either
- do not modprobe nvidia module in %%post, rmmod it instead
- Import nvidia97xx



* Mon Mar 26 2007 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.0-9755.1mdv
- 97.55
- provide libwfb.so symlink (#29751)
- don't add modules to /etc/mod{ules,probe.preload} (#29111)
- move libXvMCNVIDIA_dynamic.so.1 to %%{_libdir}/%%{name} (#29108)

* Thu Mar  1 2007 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.0-9746.3mdv
- remove XFdrake generated modprobe.conf

* Wed Feb 28 2007 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.0-9746.2mdv
- new layout for MDV 2007.1
- increase priority to match version level

* Tue Jan 16 2007 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.0-9746-1mdv
- 97.46

* Wed Nov  8 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.0-9629-1mdv
- 96.29

* Fri Nov  3 2006 Arnaud Patard <apatard@mandriva.com> 1.0-8776-1mdv
- 87.76

* Wed Sep 13 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.0-8774-3mdv
- Use an alternative for the X.org module too

* Sat Sep  9 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.0-8774-2mdk
- Use nvidia_drv.so for X.org 7.1
- Move nvidia.conf to ld.so.conf.d/GL/
- Move GL libraries to an nvidia/ subdir

* Fri Aug 25 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.0-8774-1mdk
- 87.74

* Thu Aug 24 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.0-8762-1mdk
- 87.62

* Mon Apr 10 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.0-8756-1mdk
- 87.56

* Tue Dec 27 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.0-8178-1mdk
- 81.78

* Tue Dec  6 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.0-8174-1mdk
- 81.74

* Thu Sep 29 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.0-8163-1mdk
- 81.63

* Fri Sep 16 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 7676-5mdk
- make ld.so.conf.d/%%{name}.conf config(noreplace)

* Mon Sep 12 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 7676-4mdk
- fix scriptlets

* Thu Sep  1 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 7676-3mdk
- description improvements
- ship with 32-bit tls libraries in the right subdir

* Fri Aug 26 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 7676-2mdk
- move libglx.so to an nvidia/ subdir for X.org 6.9

* Wed Aug 17 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 7676-1mdk
- 76.76

* Wed Jul  6 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.0-7667-2mdk
- ship with nvidia-bug-report.sh

* Mon Jul  4 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.0-7667-1mdk
- 76.67

* Tue Jun  7 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.0-7664-1mdk
- 76.64

* Fri Apr  8 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.0-7174-1mdk
- 71.74

* Tue Mar 15 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.0-7167-2mdk
- 1.0-7167 for Linux x86/x86-64 updates (zander, nvnews.net)

* Fri Mar 11 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.0-7167-1mdk
- 71.67

* Fri Feb 18 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.0-6633-1mdk
- 6633.

* Thu Jan 20 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.0-6629-2mdk
- ship with tls library symlinks on 10.0/corpo

* Tue Dec  7 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.0-6629-1mdk
- 6629.

* Tue Oct 26 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.0-6111-2mdk
- move to dkms build

* Thu Aug 19 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.0-6111-1mdk
- 6111.

* Wed Jul 28 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.0-6106-2mdk
- fix build with kernel 2.4

* Fri Jul  2 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.0-6106-1mdk
- 6106.

* Tue Jun  8 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.0-6098-1mdk
- 6098.

* Fri May 28 2004 Nicolas Planel <nplanel@mandrakesoft.com> 1.0-6097-1mdk
- 6097.

* Wed May 26 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.0-6096-3mdk
- move nvidia GL libs to a subdir

* Mon May 24 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.0-6096-2mdk
- lib64 and 32-bit tls fixes

* Wed May 19 2004 Nicolas Planel <nplanel@mandrakesoft.com> 1.0-6096-1mdk
- First new release for x86_64.

